Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.batik.ext.awt
Class LinearGradientPaint

    java.lang.Object
      org.apache.batik.ext.awt.MultipleGradientPaint
          org.apache.batik.ext.awt.LinearGradientPaint

All Implemented Interfaces:
  Paint, Transparency

    public final class LinearGradientPaint

extends MultipleGradientPaint

The `LinearGradientPaint` class provides a way to fill a `Shape` with a linear color gradient pattern. The user may specify 2 or more gradient colors, and this paint will provide an interpolation between each color. The user also specifies start and end points which define where in user space the color gradient should begin and end.

The user must provide an array of floats specifying how to distribute the colors along the gradient. These values should range from 0.0 to 1.0 and act like keyframes along the gradient (they mark where the gradient should be exactly a particular color).

For example:
``

Point2D start = new Point2D.Float(0, 0);
Point2D end = new Point2D.Float(100,100);
float[] dist = {0.0, 0.2, 1.0};
Color[] colors = {Color.red, Color.white, Color.blue};
LinearGradientPaint p = new LinearGradientPaint(start, end, dist, colors);

This code will create a LinearGradientPaint which interpolates between red and white for the first 20% of the gradient and between white and blue for the remaining 80%.

In the event that the user does not set the first keyframe value equal to 0 and the last keyframe value equal to 1, keyframes will be created at these positions and the first and last colors will be replicated there. So, if a user specifies the following arrays to construct a gradient:
{Color.blue, Color.red}, {.3, .7}
this will be converted to a gradient with the following keyframes: {Color.blue, Color.blue, Color.red, Color.red}, {0, .3, .7, 1}

The user may also select what action the LinearGradientPaint should take when filling color outside the start and end points. If no cycle method is specified, NO_CYCLE will be chosen by default, so the endpoint colors will be used to fill the remaining area.

The following image demonstrates the options NO_CYCLE and REFLECT.

The colorSpace parameter allows the user to specify in which colorspace the interpolation should be performed, default sRGB or linearized RGB.

See Also:
  `Paint`, `Graphics2D.setPaint(java.awt.Paint)`

Nested Class Summary

Nested classes/interfaces inherited from class org.apache.batik.ext.awt.MultipleGradientPaint
`MultipleGradientPaint.ColorSpaceEnum, MultipleGradientPaint.CycleMethodEnum`

Field Summary

Fields inherited from class org.apache.batik.ext.awt.MultipleGradientPaint
`colors, colorSpace, cycleMethod, fractions, gradientTransform, LINEAR_RGB, NO_CYCLE, REFLECT, REPEAT, SRGB, transparency`

Fields inherited from interface java.awt.Transparency
`BITMASK, OPAQUE, TRANSLUCENT`

Constructor Summary
`LinearGradientPaint(float startX, float startY, float endX, float endY, float[] fractions, Color[] colors)` Constructs an `LinearGradientPaint` with the default NO_CYCLE repeating method and SRGB colorspace.
`LinearGradientPaint(float startX, float startY, float endX, float endY, float[] fractions, Color[] colors, MultipleGradientPaint.CycleMethodEnum cycleMethod)` Constructs an `LinearGradientPaint` with default SRGB colorspace.
`LinearGradientPaint(Point2D start, Point2D end, float[] fractions, Color[] colors)` Constructs a `LinearGradientPaint` with the default NO_CYCLE repeating method and SRGB colorspace.
`LinearGradientPaint(Point2D start, Point2D end, float[] fractions, Color[] colors, MultipleGradientPaint.CycleMethodEnum cycleMethod, MultipleGradientPaint.ColorSpaceEnum colorSpace)` Constructs a `LinearGradientPaint`.
`LinearGradientPaint(Point2D start, Point2D end, float[] fractions, Color[] colors, MultipleGradientPaint.CycleMethodEnum cycleMethod, MultipleGradientPaint.ColorSpaceEnum colorSpace, AffineTransform gradientTransform)` Constructs a `LinearGradientPaint`.

Method Summary
`PaintContext` | `createContext(ColorModel cm, Rectangle deviceBounds, Rectangle2D userBounds, AffineTransform transform, RenderingHints hints)` Creates and returns a PaintContext used to generate the color pattern, for use by the internal rendering engine.
`Point2D` | `getEndPoint()` Returns a copy of the end point of the gradient axis
`Point2D` | `getStartPoint()` Returns a copy of the start point of the gradient axis

Methods inherited from class org.apache.batik.ext.awt.MultipleGradientPaint
`getColors, getColorSpace, getCycleMethod, getFractions, getTransform, getTransparency`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### LinearGradientPaint

    public LinearGradientPaint(float startX,
                               float startY,
                               float endX,
                               float endY,
                               float[] fractions,
                               Color[] colors)

  Constructs an `LinearGradientPaint` with the default NO_CYCLE repeating method and SRGB colorspace.

  Parameters:
    `startX` - the x coordinate of the gradient axis start point in user space
    `startY` - the y coordinate of the gradient axis start point in user space
    `endX` - the x coordinate of the gradient axis end point in user space
    `endY` - the y coordinate of the gradient axis end point in user space
    `fractions` - numbers ranging from 0.0 to 1.0 specifying the distribution of colors along the gradient
    `colors` - array of colors corresponding to each fractional value
  Throws:
    `IllegalArgumentException` - if start and end points are the same points, or if fractions.length != colors.length, or if colors is less than 2 in size.

### LinearGradientPaint

    public LinearGradientPaint(float startX,
                               float startY,
                               float endX,
                               float endY,
                               float[] fractions,
                               Color[] colors,
                               MultipleGradientPaint.CycleMethodEnum cycleMethod)

  Constructs an `LinearGradientPaint` with default SRGB colorspace.

  Parameters:
    `startX` - the x coordinate of the gradient axis start point in user space
    `startY` - the y coordinate of the gradient axis start point in user space
    `endX` - the x coordinate of the gradient axis end point in user space
    `endY` - the y coordinate of the gradient axis end point in user space
    `fractions` - numbers ranging from 0.0 to 1.0 specifying the distribution of colors along the gradient
    `colors` - array of colors corresponding to each fractional value
    `cycleMethod` - either NO_CYCLE, REFLECT, or REPEAT
  Throws:
    `IllegalArgumentException` - if start and end points are the same points, or if fractions.length != colors.length, or if colors is less than 2 in size.

### LinearGradientPaint

    public LinearGradientPaint(Point2D start,
                               Point2D end,
                               float[] fractions,
                               Color[] colors)

  Constructs a `LinearGradientPaint` with the default NO_CYCLE repeating method and SRGB colorspace.

  Parameters:
    `start` - the gradient axis start `Point` in user space
    `end` - the gradient axis end `Point` in user space
    `fractions` - numbers ranging from 0.0 to 1.0 specifying the distribution of colors along the gradient
    `colors` - array of colors corresponding to each fractional value
  Throws:
    `NullPointerException` - if one of the points is null
    `IllegalArgumentException` - if start and end points are the same points, or if fractions.length != colors.length, or if colors is less than 2 in size.

### LinearGradientPaint

    public LinearGradientPaint(Point2D start,
                               Point2D end,
                               float[] fractions,
                               Color[] colors,
                               MultipleGradientPaint.CycleMethodEnum cycleMethod,
                               MultipleGradientPaint.ColorSpaceEnum colorSpace)

  Constructs a `LinearGradientPaint`.

  Parameters:
    `start` - the gradient axis start `Point` in user space
    `end` - the gradient axis end `Point` in user space
    `fractions` - numbers ranging from 0.0 to 1.0 specifying the distribution of colors along the gradient
    `colors` - array of colors corresponding to each fractional value
    `cycleMethod` - either NO_CYCLE, REFLECT, or REPEAT
    `colorSpace` - which colorspace to use for interpolation, either SRGB or LINEAR_RGB
  Throws:
    `NullPointerException` - if one of the points is null
    `IllegalArgumentException` - if start and end points are the same points, or if fractions.length != colors.length, or if colors is less than 2 in size.

### LinearGradientPaint

    public LinearGradientPaint(Point2D start,
                               Point2D end,
                               float[] fractions,
                               Color[] colors,
                               MultipleGradientPaint.CycleMethodEnum cycleMethod,
                               MultipleGradientPaint.ColorSpaceEnum colorSpace,
                               AffineTransform gradientTransform)

  Constructs a `LinearGradientPaint`.

  Parameters:
    `start` - the gradient axis start `Point` in user space
    `end` - the gradient axis end `Point` in user space
    `fractions` - numbers ranging from 0.0 to 1.0 specifying the distribution of colors along the gradient
    `colors` - array of colors corresponding to each fractional value
    `cycleMethod` - either NO_CYCLE, REFLECT, or REPEAT
    `colorSpace` - which colorspace to use for interpolation, either SRGB or LINEAR_RGB
    `gradientTransform` - transform to apply to the gradient
  Throws:
    `NullPointerException` - if one of the points is null, or gradientTransform is null
    `IllegalArgumentException` - if start and end points are the same points, or if fractions.length != colors.length, or if colors is less than 2 in size.

Method Detail

### createContext

    public PaintContext createContext(ColorModel cm,
                                      Rectangle deviceBounds,
                                      Rectangle2D userBounds,
                                      AffineTransform transform,
                                      RenderingHints hints)

  Creates and returns a PaintContext used to generate the color pattern, for use by the internal rendering engine.

  Parameters:
    `cm` - `ColorModel` that receives the `Paint` data. This is used only as a hint.
    `deviceBounds` - the device space bounding box of the graphics primitive being rendered
    `userBounds` - the user space bounding box of the graphics primitive being rendered
    `transform` - the `AffineTransform` from user space into device space
    `hints` - the hints that the context object uses to choose between rendering alternatives
  Returns:
    the `PaintContext` that generates color patterns.
  See Also:
    `PaintContext`

### getStartPoint

    public Point2D getStartPoint()

  Returns a copy of the start point of the gradient axis

  Returns:
    a `Point2D` object that is a copy of the point that anchors the first color of this `LinearGradientPaint`.

### getEndPoint

    public Point2D getEndPoint()

  Returns a copy of the end point of the gradient axis

  Returns:
    a `Point2D` object that is a copy of the point that anchors the last color of this `LinearGradientPaint`.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2008 Apache Software Foundation. All Rights Reserved.